From 6dd9cc00889a863c421e1a9588cd112f46c81cec Mon Sep 17 00:00:00 2001
From: Aurelien Bompard <aurelien@bompard.org>
Date: Oct 26 2017 14:09:04 +0000
Subject: [PATCH 1001/1001] Merge #408 `Use Markdown to render Sticky widget`


---

diff --git a/hubs/tests/widgets/test_sticky.py b/hubs/tests/widgets/test_sticky.py
new file mode 100644
index 0000000..d4b9902
--- /dev/null
+++ b/hubs/tests/widgets/test_sticky.py
@@ -0,0 +1,25 @@
+from __future__ import unicode_literals
+
+from . import WidgetTest
+
+
+class StickyTest(WidgetTest):
+
+    plugin = "sticky"
+    initial_widget_config = {
+        "text": """| Tables        | Are           | Cool  |
+                   | ------------- |:-------------:| -----:|
+                   | col 3 is      | right-aligned | $1600 |
+                   | col 2 is      | centered      |   $12 |
+                   | zebra stripes | are neat      |    $1 |
+                """
+    }
+
+    def populate(self):
+        super(StickyTest, self).populate()
+        self._add_widget_under_test()
+
+    def test_markdown_parse(self):
+        func = self.widget.module.get_cached_functions()['ParseMarkdown']
+        result = func(self.widget).execute()
+        self.assertRegexpMatches(result, r'^<table>(?s).*</table>$')
diff --git a/hubs/widgets/sticky/__init__.py b/hubs/widgets/sticky/__init__.py
index 13c6af3..7399bff 100644
--- a/hubs/widgets/sticky/__init__.py
+++ b/hubs/widgets/sticky/__init__.py
@@ -2,8 +2,11 @@ from __future__ import unicode_literals
 
 from hubs.widgets import validators
 from hubs.widgets.base import Widget
+from hubs.widgets.caching import CachedFunction
 from hubs.widgets.view import RootWidgetView
 
+from markdown import markdown
+
 
 class Sticky(Widget):
 
@@ -11,9 +14,12 @@ class Sticky(Widget):
     label = "Sticky Note"
     position = "both"
     display_css = "card-info"
+    is_large = True
     parameters = [
         dict(
             name="text",
+            render_tag="textarea",
+            render_attributes={"rows": "30"},
             label="Text",
             default="Lorem ipsum dolor...",
             validator=validators.Text,
@@ -24,7 +30,18 @@ class Sticky(Widget):
 class BaseView(RootWidgetView):
 
     def get_context(self, instance, *args, **kwargs):
-        # TODO -- render with markdown
+        md = ParseMarkdown(instance)
         return dict(
-            text=instance.config["text"],
-            )
+            text=md()
+        )
+
+
+class ParseMarkdown(CachedFunction):
+
+    def execute(self):
+        text = self.instance.config["text"]
+        return markdown(text, extensions=['markdown.extensions.extra',
+                                          'markdown.extensions.sane_lists'])
+
+    def should_invalidate(self, message):
+        return False
